#ifndef _SOE_H_
#define _SOE_H_

#include "type.h"
#include <time.h>
#include "UWater_rtcc_driver.h"

#pragma pack(1)

#define  LENGTH_ONE_SOE   			9
#define  TOTAL_NUM_SOE    			100  	//¼¼
#define  SOE_ALL_TYPE     			0xFFFF
#define  SOE_REMARK_NOR   			0   	//SOEעͨ
//#define  SOE_REMARK_A_PIPE_BAD   	1   	//SOEע
//#define  SOE_REMARK_B_PIPE_BAD   	2   	//SOEע
//#define  SOE_VALVE_CLOSE   		 	1   	//SOEעչ
//#define  SOE_VALVE_CLOSE_LOCK    	2   	//SOEעȨ
//#define  SOE_VALVE_CLOSE_LOCK    	2   	//SOEעȨ
#define  SOE_NUM          			10  	//SOE¼ͬʱԷ10

#define  EEP_ADDR_SOE_BASE          EEP_SOE_ADDR  //0x1000
#define  EEP_ADDR_SOE_WR_POINT      (EEP_ADDR_SOE_BASE + TOTAL_NUM_SOE*9)
#define EEP_DATA_LEN_SOE  (LENGTH_ONE_SOE*TOTAL_NUM_SOE+1)

#define MAX_NUM_READ_SOE	25			//ζȡSOE¼	

enum SOE_TYPE{	
	SOE_START_ID0 = 0x0000,			//ʼַ--SOE
	SOE_VALVE_OPEN,					//ͨ
	SOE_VALVE_OPEN_EMERGENCY,		//Ӧ
	SOE_VALVE_CLOSE,				//ͨط
	SOE_VALVE_CLOSE_EMERGENCY,		//Ӧط
	SOE_VALVE_CLOSE_LOCK,			//Ȩ޹ط		
	SOE_DEVICE_RESTART,				//ն
	SOE_BAT_LOW_LEVEL,				//Ƿѹ
	SOE_MAGNETIC_ATTACK,			//Ÿ
	SOE_OVER_FLOW,					//
	SOE_BACK_FLOW,					//ת
	SOE_MODEL_ERROE,				//ģ
	SOE_TAKE_OFF_METER,				//
	SOE_INSERT_SOMETHING,			//
	SOE_SWITCH_INTER_OSCI,			//лڲ
	SOE_MANUAL_UPLOAD,				//ֶϱ
	SOE_SET_INIT_VALUE,				//õ
	SOE_17_BLE_ADV_ERR,
	SOE_18_BLE_ERR,
	SOE_19_BLE_TRIM,
	SOE_20_BLE_INIT, //ʼ
/*****Լ¼**********/
	//
	SOE_SY_OVER_FLOW = 1001,//--
	SOE_SY_NO_WATER, //չܱ--
	SOE_SY_REVERSE_FLOW, //--
	SOE_SY_LEAK_FLOW,//©ˮ--
	SOE_SY_LOW_POWER,//͵ѹ---
	SOE_SY_TEMP_OVER,//¶ȳΧ--
	SOE_SY_SHELL_OPEN,//ϸǱ
	SOE_SY_VALVE_ERR,//Ųʧ--
	SOE_SY_CIRCLE_WRONG,//·--
	SOE_SY_TEMP_SHORT,//¶·--
	SOE_SY_TEMP_OPEN,//¿·--
	//¼
	SOE_SY_VALVE_OPEN=1021,//--
	SOE_SY_VALVE_CLOSE,//ط--
	SOE_SY_SYS_RESET,//ϵͳ--1023
	SOE_SY_FROZEN_CLEAR,//----
	SOE_SY_CURRENT_CLEAR,//ˮ0----
	//Զ屨¼
	SOE_SY_LOW_AMP = 1101,//--
	SOE_SY_GP30_COMERR,//GP30ͨŹ--
	SOE_SY_TOF_OVER,//TOF--
	
	SOE_END_ID0 = 0xFFF0,
	//Զ¼
	SOE_START_ID1 = 0xFFF8,
	SOE_END_ID1,
};

enum{	
	SAVE_SOE_S0 = 0,
	SAVE_SOE_S1,
	SAVE_SOE_S2,
	SAVE_SOE_S3
};

typedef struct
{
    u16 soe_type[SOE_NUM];
    DateTime_noweek soe_time[SOE_NUM];
    u8 soe_data[SOE_NUM];
	u8 soe_cnt;
	u8 soe_record_cnt;
} SOE;

typedef struct
{
	 u16 soe_type;
	 DateTime_noweek soe_time;
	 u8  soe_data;
} ONE_SOE;

void SaveNewSoe(u16 soe_type,u8 soe_data);
u8 Check_One_Soe (u16 soe_type,DateTime_noweek *start_time,DateTime_noweek *end_time,ONE_SOE *soe_read);
void SoeInit(void);
void SoeDealApp(void);
u8 SaveSoeToEEIfIdle(void);
//#pragma pack()


#endif
